- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# FbxTrimNurbsSurface Class Reference

This reference page is linked to from the following overview topics: Supported Scene Elements, FBX Node Attributes, List of Python Fbx classes.

Search for all occurrences

## Detailed Description

FbxTrimNurbsSurface describes a NURBS surface with regions trimmed or cut away with trimming boundaries.

Definition at line 121 of file fbxtrimnurbssurface.h.

`#include <fbxtrimnurbssurface.h>`

Inheritance diagram for FbxTrimNurbsSurface:
[legend]

List of all members.

## Public Member Functions
virtual FbxNodeAttribute::EType | GetAttributeType () const
| Returns the type of node attribute.
int | GetTrimRegionCount () const
| Returns the number of regions on this trimmed NURBS surface.
void | BeginTrimRegion ()
| Calls this function before adding boundaries to a new trim region.
void | EndTrimRegion ()
| Calls this function after the last boundary for a given region is added.
bool | AddBoundary (FbxBoundary *pBoundary)
| Appends a trimming boundary to the set of trimming boundaries.
FbxBoundary * | GetBoundary (int pIndex, int pRegionIndex=0)
| Returns the boundary at a given index for the specified region.
FbxBoundary const * | GetBoundary (int pIndex, int pRegionIndex=0) const
| Returns the boundary at a given index for the specified region.
int | GetBoundaryCount (int pRegionIndex=0) const
| Returns the number of boundaries for a given region.
void | SetNurbsSurface (FbxNurbsSurface const *pNurbs)
| Sets the NURBS surface that is trimmed by the trimming boundaries.
FbxNurbsSurface * | GetNurbsSurface ()
| Returns the NURBS surface that is trimmed by the trim boundaries.
FbxNurbsSurface const * | GetNurbsSurface () const
| Returns the NURBS surface that is trimmed by the trim boundaries.
void | SetFlipNormals (bool pFlip)
| Sets the flag which indicates whether the surface normals are flipped.
bool | GetFlipNormals () const
| Checks if the normals are flipped.
virtual int | GetControlPointsCount () const
| Returns the number of control points.
virtual void | SetControlPointAt (FbxVector4 &pCtrlPoint, FbxVector4 &pNormal, int pIndex)
| Sets the control point and the normal values for a specified index.
virtual FbxVector4 * | GetControlPoints () const
| Returns the NURBS surface's control points.
virtual FbxObject & | Copy (const FbxObject &pObject)
| Copy an object content into this object.
bool | IsValid (bool mustClosed=true)
void | ClearBoundaries ()
void | CopyBoundaries (FbxTrimNurbsSurface const &pOther)
bool | IsValid (int pRegion, bool mustClosed=true)
void | RebuildRegions ()
## Protected Member Functions
| FbxTrimNurbsSurface (FbxManager &pManager, char const *pName)

## Constructor & Destructor Documentation

FbxTrimNurbsSurface | ( | FbxManager & | pManager,
|  | char const * | pName
| ) |  | `[protected]`

## Member Function Documentation

virtual FbxNodeAttribute::EType GetAttributeType | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the type of node attribute.

Reimplemented from FbxGeometry.

int GetTrimRegionCount | ( |  | ) | const

Search for all occurrences

Returns the number of regions on this trimmed NURBS surface.

Note: There is always at least one region.

Returns:
  The number of regions

void BeginTrimRegion | ( |  | ) |

Search for all occurrences

Calls this function before adding boundaries to a new trim region.

The number of regions is incremented on this call.

void EndTrimRegion | ( |  | ) |

Search for all occurrences

Calls this function after the last boundary for a given region is added.

If no boundaries are added between the calls to BeginTrimRegion and EndTrimRegion, the last region is removed.

bool AddBoundary | ( | FbxBoundary * | pBoundary | ) |

Search for all occurrences

Appends a trimming boundary to the set of trimming boundaries.

The first boundary specified for a given trim region should be the outer boundary. All other boundaries are inner boundaries. This must be called after a call to BeginTrimRegion(). Boundaries cannot be shared among regions. Duplicate the boundary if necessary.

Parameters:

  pBoundary | The boundary to add.

Returns:
  `True` if the boundary is added successfully. If the boundary is not added successfully, returns `false`.

FbxBoundary* GetBoundary | ( | int | pIndex,
|  | int | pRegionIndex = `0`
| ) |  |

Search for all occurrences

Returns the boundary at a given index for the specified region.

Parameters:

  pIndex | The index of the boundary to retrieve, no bound checking is done.
  pRegionIndex | The index of the region which is bordered by the boundary.

Returns:
  The trimming boundary at index pIndex, if pIndex is in the range [0, GetBoundaryCount() ), otherwise the result is undefined.

FbxBoundary const* GetBoundary | ( | int | pIndex,
|  | int | pRegionIndex = `0`
| ) |  | const

Search for all occurrences

Returns the boundary at a given index for the specified region.

Parameters:

  pIndex | The index of the boundary to retrieve, no bound checking is done.
  pRegionIndex | The index of the region which is bordered by the boundary.

Returns:
  The trimming boundary at index pIndex, if pIndex is in the range [0, GetBoundaryCount() ), otherwise the result is undefined.

int GetBoundaryCount | ( | int | pRegionIndex = `0` | ) | const

Search for all occurrences

Returns the number of boundaries for a given region.

Parameters:

  pRegionIndex | The index of the region.

Returns:
  The number of trim boundaries for the given region.

void SetNurbsSurface | ( | FbxNurbsSurface const * | pNurbs | ) |

Search for all occurrences

Sets the NURBS surface that is trimmed by the trimming boundaries.

Parameters:

  pNurbs | The NURBS surface to be trimmed.

FbxNurbsSurface* GetNurbsSurface | ( |  | ) |

Search for all occurrences

Returns the NURBS surface that is trimmed by the trim boundaries.

Returns:
  A pointer to the (untrimmed) NURBS surface.

FbxNurbsSurface const* GetNurbsSurface | ( |  | ) | const

Search for all occurrences

Returns the NURBS surface that is trimmed by the trim boundaries.

Returns:
  A pointer to the (untrimmed) NURBS surface.

void SetFlipNormals | ( | bool | pFlip | ) | `[inline]`

Search for all occurrences

Sets the flag which indicates whether the surface normals are flipped.

You can flip the normals of the surface to reverse the surface.

Parameters:

  pFlip | If `true`, the surface is reversed. If it is false, the surface is not reversed.

Definition at line 200 of file fbxtrimnurbssurface.h.

    { mFlipNormals = pFlip; }

bool GetFlipNormals | ( |  | ) | const `[inline]`

Search for all occurrences

Checks if the normals are flipped.

Returns:
  `True` if normals are flipped, returns `false` if they are not flipped.

Definition at line 205 of file fbxtrimnurbssurface.h.

    { return  mFlipNormals; }

virtual int GetControlPointsCount | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the number of control points.

Returns:
  The number of control points allocated in the geometry.

Reimplemented from FbxGeometryBase.

virtual void SetControlPointAt | ( | FbxVector4 & | pCtrlPoint,
|  | FbxVector4 & | pNormal,
|  | int | pIndex
| ) |  | `[virtual]`

Search for all occurrences

Sets the control point and the normal values for a specified index.

Parameters:

  pCtrlPoint | The value of the control point.
  pNormal | The value of the normal.
  pIndex | The specified index.

virtual FbxVector4* GetControlPoints | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the NURBS surface's control points.

Reimplemented from FbxGeometryBase.

virtual FbxObject& Copy | ( | const FbxObject & | pObject | ) | `[virtual]`

Search for all occurrences

Copy an object content into this object.

Parameters:

  pObject | The source object to copy data from.

Returns:
  Returns the destination object being modified by the source.

Remarks:
  This function replace the assignment operator (operator=). It will copy all property values and the name. Connections are NOT copied.

Reimplemented from FbxGeometry.

bool IsValid | ( | bool | mustClosed = `true` | ) |

Search for all occurrences

Parameters:

  mustClosed | boundary curve must be closed

void ClearBoundaries | ( |  | ) |

Search for all occurrences

void CopyBoundaries | ( | FbxTrimNurbsSurface const & | pOther | ) |

Search for all occurrences

bool IsValid | ( | int | pRegion,
|  | bool | mustClosed = `true`
| ) |  |

Search for all occurrences

void RebuildRegions | ( |  | ) |

Search for all occurrences

The documentation for this class was generated from the following file:

- fbxsdk/scene/geometry/fbxtrimnurbssurface.h

FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface
FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface FbxTrimNurbsSurface